package com.hai.dao;

import com.hai.entity.ApiBlxCoupon;
import com.hai.entity.ApiBlxCouponExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface ApiBlxCouponMapper extends ApiBlxCouponMapperExt {
    @SelectProvider(type=ApiBlxCouponSqlProvider.class, method="countByExample")
    long countByExample(ApiBlxCouponExample example);

    @DeleteProvider(type=ApiBlxCouponSqlProvider.class, method="deleteByExample")
    int deleteByExample(ApiBlxCouponExample example);

    @Delete({
        "delete from api_blx_coupon",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into api_blx_coupon (coupon_code, coupon_name, ",
        "receive_type, use_start_time, ",
        "use_end_time, denomination, ",
        "min_price, receive_limit, ",
        "receive_days, create_time, ",
        "update_time, coupon_status, ",
        "ext_1, ext_2, ext_3, ",
        "ext_4, ext_5, ext_6)",
        "values (#{couponCode,jdbcType=VARCHAR}, #{couponName,jdbcType=VARCHAR}, ",
        "#{receiveType,jdbcType=INTEGER}, #{useStartTime,jdbcType=TIMESTAMP}, ",
        "#{useEndTime,jdbcType=TIMESTAMP}, #{denomination,jdbcType=INTEGER}, ",
        "#{minPrice,jdbcType=INTEGER}, #{receiveLimit,jdbcType=INTEGER}, ",
        "#{receiveDays,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{couponStatus,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR}, ",
        "#{ext4,jdbcType=VARCHAR}, #{ext5,jdbcType=VARCHAR}, #{ext6,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(ApiBlxCoupon record);

    @InsertProvider(type=ApiBlxCouponSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(ApiBlxCoupon record);

    @SelectProvider(type=ApiBlxCouponSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="coupon_code", property="couponCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="coupon_name", property="couponName", jdbcType=JdbcType.VARCHAR),
        @Result(column="receive_type", property="receiveType", jdbcType=JdbcType.INTEGER),
        @Result(column="use_start_time", property="useStartTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="use_end_time", property="useEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="denomination", property="denomination", jdbcType=JdbcType.INTEGER),
        @Result(column="min_price", property="minPrice", jdbcType=JdbcType.INTEGER),
        @Result(column="receive_limit", property="receiveLimit", jdbcType=JdbcType.INTEGER),
        @Result(column="receive_days", property="receiveDays", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="coupon_status", property="couponStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_4", property="ext4", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_5", property="ext5", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_6", property="ext6", jdbcType=JdbcType.VARCHAR)
    })
    List<ApiBlxCoupon> selectByExample(ApiBlxCouponExample example);

    @Select({
        "select",
        "id, coupon_code, coupon_name, receive_type, use_start_time, use_end_time, denomination, ",
        "min_price, receive_limit, receive_days, create_time, update_time, coupon_status, ",
        "ext_1, ext_2, ext_3, ext_4, ext_5, ext_6",
        "from api_blx_coupon",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="coupon_code", property="couponCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="coupon_name", property="couponName", jdbcType=JdbcType.VARCHAR),
        @Result(column="receive_type", property="receiveType", jdbcType=JdbcType.INTEGER),
        @Result(column="use_start_time", property="useStartTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="use_end_time", property="useEndTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="denomination", property="denomination", jdbcType=JdbcType.INTEGER),
        @Result(column="min_price", property="minPrice", jdbcType=JdbcType.INTEGER),
        @Result(column="receive_limit", property="receiveLimit", jdbcType=JdbcType.INTEGER),
        @Result(column="receive_days", property="receiveDays", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="coupon_status", property="couponStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_4", property="ext4", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_5", property="ext5", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_6", property="ext6", jdbcType=JdbcType.VARCHAR)
    })
    ApiBlxCoupon selectByPrimaryKey(Long id);

    @UpdateProvider(type=ApiBlxCouponSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") ApiBlxCoupon record, @Param("example") ApiBlxCouponExample example);

    @UpdateProvider(type=ApiBlxCouponSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") ApiBlxCoupon record, @Param("example") ApiBlxCouponExample example);

    @UpdateProvider(type=ApiBlxCouponSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(ApiBlxCoupon record);

    @Update({
        "update api_blx_coupon",
        "set coupon_code = #{couponCode,jdbcType=VARCHAR},",
          "coupon_name = #{couponName,jdbcType=VARCHAR},",
          "receive_type = #{receiveType,jdbcType=INTEGER},",
          "use_start_time = #{useStartTime,jdbcType=TIMESTAMP},",
          "use_end_time = #{useEndTime,jdbcType=TIMESTAMP},",
          "denomination = #{denomination,jdbcType=INTEGER},",
          "min_price = #{minPrice,jdbcType=INTEGER},",
          "receive_limit = #{receiveLimit,jdbcType=INTEGER},",
          "receive_days = #{receiveDays,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "coupon_status = #{couponStatus,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR},",
          "ext_4 = #{ext4,jdbcType=VARCHAR},",
          "ext_5 = #{ext5,jdbcType=VARCHAR},",
          "ext_6 = #{ext6,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(ApiBlxCoupon record);
}