package com.hai.dao;

import com.hai.entity.GoodsPresentRecord;
import com.hai.entity.GoodsPresentRecordExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsPresentRecordMapper extends GoodsPresentRecordMapperExt {
    @SelectProvider(type=GoodsPresentRecordSqlProvider.class, method="countByExample")
    long countByExample(GoodsPresentRecordExample example);

    @DeleteProvider(type=GoodsPresentRecordSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsPresentRecordExample example);

    @Delete({
        "delete from goods_present_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into goods_present_record (present_id, order_no, ",
        "order_id, child_order_id, ",
        "`type`, source_id, source_name, ",
        "num, create_time, ",
        "update_time, op_id, ",
        "op_name, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{presentId,jdbcType=BIGINT}, #{orderNo,jdbcType=VARCHAR}, ",
        "#{orderId,jdbcType=BIGINT}, #{childOrderId,jdbcType=BIGINT}, ",
        "#{type,jdbcType=INTEGER}, #{sourceId,jdbcType=BIGINT}, #{sourceName,jdbcType=VARCHAR}, ",
        "#{num,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{opId,jdbcType=BIGINT}, ",
        "#{opName,jdbcType=VARCHAR}, #{status,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsPresentRecord record);

    @InsertProvider(type=GoodsPresentRecordSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsPresentRecord record);

    @SelectProvider(type=GoodsPresentRecordSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="present_id", property="presentId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_name", property="sourceName", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsPresentRecord> selectByExample(GoodsPresentRecordExample example);

    @Select({
        "select",
        "id, present_id, order_no, order_id, child_order_id, `type`, source_id, source_name, ",
        "num, create_time, update_time, op_id, op_name, `status`, ext_1, ext_2, ext_3",
        "from goods_present_record",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="present_id", property="presentId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_no", property="orderNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.BIGINT),
        @Result(column="source_name", property="sourceName", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    GoodsPresentRecord selectByPrimaryKey(Long id);

    @UpdateProvider(type=GoodsPresentRecordSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsPresentRecord record, @Param("example") GoodsPresentRecordExample example);

    @UpdateProvider(type=GoodsPresentRecordSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsPresentRecord record, @Param("example") GoodsPresentRecordExample example);

    @UpdateProvider(type=GoodsPresentRecordSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(GoodsPresentRecord record);

    @Update({
        "update goods_present_record",
        "set present_id = #{presentId,jdbcType=BIGINT},",
          "order_no = #{orderNo,jdbcType=VARCHAR},",
          "order_id = #{orderId,jdbcType=BIGINT},",
          "child_order_id = #{childOrderId,jdbcType=BIGINT},",
          "`type` = #{type,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=BIGINT},",
          "source_name = #{sourceName,jdbcType=VARCHAR},",
          "num = #{num,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(GoodsPresentRecord record);
}