package com.hai.dao;

import com.hai.entity.GoodsRegionFreight;
import com.hai.entity.GoodsRegionFreightExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsRegionFreightMapper extends GoodsRegionFreightMapperExt {
    @SelectProvider(type=GoodsRegionFreightSqlProvider.class, method="countByExample")
    long countByExample(GoodsRegionFreightExample example);

    @DeleteProvider(type=GoodsRegionFreightSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsRegionFreightExample example);

    @Delete({
        "delete from goods_region_freight",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into goods_region_freight (region_name, region_id, ",
        "free_post_price, freight_price, ",
        "`status`, create_time, ",
        "update_time, op_id, ",
        "op_name, ext_1, ext_2, ",
        "ext_3)",
        "values (#{regionName,jdbcType=VARCHAR}, #{regionId,jdbcType=VARCHAR}, ",
        "#{freePostPrice,jdbcType=DECIMAL}, #{freightPrice,jdbcType=DECIMAL}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{opId,jdbcType=BIGINT}, ",
        "#{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsRegionFreight record);

    @InsertProvider(type=GoodsRegionFreightSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsRegionFreight record);

    @SelectProvider(type=GoodsRegionFreightSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="region_name", property="regionName", jdbcType=JdbcType.VARCHAR),
        @Result(column="region_id", property="regionId", jdbcType=JdbcType.VARCHAR),
        @Result(column="free_post_price", property="freePostPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="freight_price", property="freightPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsRegionFreight> selectByExample(GoodsRegionFreightExample example);

    @Select({
        "select",
        "id, region_name, region_id, free_post_price, freight_price, `status`, create_time, ",
        "update_time, op_id, op_name, ext_1, ext_2, ext_3",
        "from goods_region_freight",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="region_name", property="regionName", jdbcType=JdbcType.VARCHAR),
        @Result(column="region_id", property="regionId", jdbcType=JdbcType.VARCHAR),
        @Result(column="free_post_price", property="freePostPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="freight_price", property="freightPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    GoodsRegionFreight selectByPrimaryKey(Long id);

    @UpdateProvider(type=GoodsRegionFreightSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsRegionFreight record, @Param("example") GoodsRegionFreightExample example);

    @UpdateProvider(type=GoodsRegionFreightSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsRegionFreight record, @Param("example") GoodsRegionFreightExample example);

    @UpdateProvider(type=GoodsRegionFreightSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(GoodsRegionFreight record);

    @Update({
        "update goods_region_freight",
        "set region_name = #{regionName,jdbcType=VARCHAR},",
          "region_id = #{regionId,jdbcType=VARCHAR},",
          "free_post_price = #{freePostPrice,jdbcType=DECIMAL},",
          "freight_price = #{freightPrice,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(GoodsRegionFreight record);
}