package com.hai.dao;

import com.hai.entity.HighDiscountPackageAgentRecord;
import com.hai.entity.HighDiscountPackageAgentRecordExample.Criteria;
import com.hai.entity.HighDiscountPackageAgentRecordExample.Criterion;
import com.hai.entity.HighDiscountPackageAgentRecordExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighDiscountPackageAgentRecordSqlProvider {

    public String countByExample(HighDiscountPackageAgentRecordExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_discount_package_agent_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighDiscountPackageAgentRecordExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_discount_package_agent_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighDiscountPackageAgentRecord record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_discount_package_agent_record");
        
        if (record.getDiscountPackageTitle() != null) {
            sql.VALUES("discount_package_title", "#{discountPackageTitle,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPackageId() != null) {
            sql.VALUES("discount_package_id", "#{discountPackageId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.VALUES("agent_name", "#{agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getCount() != null) {
            sql.VALUES("`count`", "#{count,jdbcType=INTEGER}");
        }
        
        if (record.getFrontCount() != null) {
            sql.VALUES("front_count", "#{frontCount,jdbcType=INTEGER}");
        }
        
        if (record.getAfterCount() != null) {
            sql.VALUES("after_count", "#{afterCount,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpId() != null) {
            sql.VALUES("op_id", "#{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.VALUES("op_name", "#{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighDiscountPackageAgentRecordExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("discount_package_title");
        sql.SELECT("discount_package_id");
        sql.SELECT("agent_name");
        sql.SELECT("agent_id");
        sql.SELECT("`count`");
        sql.SELECT("front_count");
        sql.SELECT("after_count");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("`status`");
        sql.SELECT("op_id");
        sql.SELECT("op_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_discount_package_agent_record");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighDiscountPackageAgentRecord record = (HighDiscountPackageAgentRecord) parameter.get("record");
        HighDiscountPackageAgentRecordExample example = (HighDiscountPackageAgentRecordExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_discount_package_agent_record");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPackageTitle() != null) {
            sql.SET("discount_package_title = #{record.discountPackageTitle,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPackageId() != null) {
            sql.SET("discount_package_id = #{record.discountPackageId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.SET("agent_name = #{record.agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getCount() != null) {
            sql.SET("`count` = #{record.count,jdbcType=INTEGER}");
        }
        
        if (record.getFrontCount() != null) {
            sql.SET("front_count = #{record.frontCount,jdbcType=INTEGER}");
        }
        
        if (record.getAfterCount() != null) {
            sql.SET("after_count = #{record.afterCount,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_package_agent_record");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("discount_package_title = #{record.discountPackageTitle,jdbcType=VARCHAR}");
        sql.SET("discount_package_id = #{record.discountPackageId,jdbcType=BIGINT}");
        sql.SET("agent_name = #{record.agentName,jdbcType=VARCHAR}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("`count` = #{record.count,jdbcType=INTEGER}");
        sql.SET("front_count = #{record.frontCount,jdbcType=INTEGER}");
        sql.SET("after_count = #{record.afterCount,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighDiscountPackageAgentRecordExample example = (HighDiscountPackageAgentRecordExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighDiscountPackageAgentRecord record) {
        SQL sql = new SQL();
        sql.UPDATE("high_discount_package_agent_record");
        
        if (record.getDiscountPackageTitle() != null) {
            sql.SET("discount_package_title = #{discountPackageTitle,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPackageId() != null) {
            sql.SET("discount_package_id = #{discountPackageId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentName() != null) {
            sql.SET("agent_name = #{agentName,jdbcType=VARCHAR}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getCount() != null) {
            sql.SET("`count` = #{count,jdbcType=INTEGER}");
        }
        
        if (record.getFrontCount() != null) {
            sql.SET("front_count = #{frontCount,jdbcType=INTEGER}");
        }
        
        if (record.getAfterCount() != null) {
            sql.SET("after_count = #{afterCount,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighDiscountPackageAgentRecordExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}