package com.hai.dao;

import com.hai.entity.HighGroupCode;
import com.hai.entity.HighGroupCodeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighGroupCodeMapper extends HighGroupCodeMapperExt {
    @SelectProvider(type=HighGroupCodeSqlProvider.class, method="countByExample")
    long countByExample(HighGroupCodeExample example);

    @DeleteProvider(type=HighGroupCodeSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighGroupCodeExample example);

    @Delete({
        "delete from high_group_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_group_code (user_id, order_id, ",
        "store_id, group_id, ",
        "group_code, code_img_url, ",
        "expiration_time, create_time, ",
        "update_time, `status`, ",
        "op_id, op_name, ext_1, ",
        "ext_2, ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{orderId,jdbcType=BIGINT}, ",
        "#{storeId,jdbcType=BIGINT}, #{groupId,jdbcType=BIGINT}, ",
        "#{groupCode,jdbcType=VARCHAR}, #{codeImgUrl,jdbcType=VARCHAR}, ",
        "#{expirationTime,jdbcType=TIMESTAMP}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighGroupCode record);

    @InsertProvider(type=HighGroupCodeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighGroupCode record);

    @SelectProvider(type=HighGroupCodeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="group_id", property="groupId", jdbcType=JdbcType.BIGINT),
        @Result(column="group_code", property="groupCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="code_img_url", property="codeImgUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="expiration_time", property="expirationTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighGroupCode> selectByExample(HighGroupCodeExample example);

    @Select({
        "select",
        "id, user_id, order_id, store_id, group_id, group_code, code_img_url, expiration_time, ",
        "create_time, update_time, `status`, op_id, op_name, ext_1, ext_2, ext_3",
        "from high_group_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="order_id", property="orderId", jdbcType=JdbcType.BIGINT),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="group_id", property="groupId", jdbcType=JdbcType.BIGINT),
        @Result(column="group_code", property="groupCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="code_img_url", property="codeImgUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="expiration_time", property="expirationTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighGroupCode selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighGroupCodeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighGroupCode record, @Param("example") HighGroupCodeExample example);

    @UpdateProvider(type=HighGroupCodeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighGroupCode record, @Param("example") HighGroupCodeExample example);

    @UpdateProvider(type=HighGroupCodeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighGroupCode record);

    @Update({
        "update high_group_code",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "order_id = #{orderId,jdbcType=BIGINT},",
          "store_id = #{storeId,jdbcType=BIGINT},",
          "group_id = #{groupId,jdbcType=BIGINT},",
          "group_code = #{groupCode,jdbcType=VARCHAR},",
          "code_img_url = #{codeImgUrl,jdbcType=VARCHAR},",
          "expiration_time = #{expirationTime,jdbcType=TIMESTAMP},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighGroupCode record);
}