package com.hai.order.model;

import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

/**
 * 创建订单参数模型
 * @className: CreateOrderModel
 * @author: HuRui
 * @date: 2022/8/16
 **/
@Data
public class CreateOrderModel {

    /**
     * 公司id
     */
    private Long companyId;

    /**
     * 订单号
     */
    private String orderNo;

    /**
     * 合单订单号
     */
    private String combineOrderNo;

    /**
     * 用户id
     */
    private Long memId;

    /**
     * 用户名称
     */
    private String memName;

    /**
     * 用户手机号
     */
    private String memPhone;

    /**
     * 推广码
     */
    private String promoteCode;

    /**
     * 用户优惠券关系id
     */
    private Long memDiscountId;

    /**
     * 支付积分（金币）
     */
    private Integer payGold;

    /**
     * 支付密码
     */
    private String payPwd;

    /**
     * 备注
     */
    private String remarks;

    /**
     * 收货地址
     */
    private Long deliveryAddressId;

    /**
     * 产品类型
     1：星巴克
     2：肯德基
     3：会员充值
     4：积分充值
     5：购买卡券
     6：加油服务
     7：优惠券包
     8：汇联通充值
     9：话费充值
     10:电影票
     11:贵州中石化
     12:实物商品
     */
    private Integer productType;

    /**
     * 子订单参数模型
     */
    private List<CreateOrderChildModel> childOrderList;


}
