package com.hai.order.model;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 订单退款模型
 * @className: ExportGasOrderModel
 * @author: 袁野
 * @date: 2022/10/28
 **/
@Data
public class ExportOrderMobileModel {

    @ColumnWidth(25)
    @ExcelProperty("标题")
    private String title;

    @ColumnWidth(15)
    @ExcelProperty("客户电话")
    private String memPhone;

    @ColumnWidth(25)
    @ExcelProperty("交易单号")
    private String orderNo;

    @ColumnWidth(25)
    @ExcelProperty("充值订单号")
    private String rechargeOrderNo;

    @ColumnWidth(25)
    @ExcelProperty("充值子订单号")
    private String childOrderNo;


    @ColumnWidth(15)
    @ExcelProperty("充值平台")
    private String rechargePlatform;

    @ColumnWidth(13)
    @ExcelProperty(value = "支付方式")
    private String payType;

    @ColumnWidth(22)
    @ExcelProperty(value = "卡号")
    private String memCardNo;

    @ColumnWidth(13)
    @ExcelProperty(value = "应付金额")
    private BigDecimal payablePrice;

    @ColumnWidth(13)
    @ExcelProperty(value = "实付金额")
    private BigDecimal payPrice;

    @ColumnWidth(15)
    @ExcelProperty("订单状态")
    private String orderStatus;



    @ColumnWidth(15)
    @ExcelProperty("创建时间")
    private Date createTime;

    @ColumnWidth(15)
    @ExcelProperty("支付时间")
    private Date payTime;

    @ColumnWidth(15)
    @ExcelProperty("完成时间")
    private Date finishTime;

    @ColumnWidth(15)
    @ExcelProperty("退款时间")
    private Date refundTime;

    @ColumnWidth(15)
    @ExcelProperty("备注")
    private String remark;

}
